#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>
#include <sstream>
#include <string>

using namespace std;


struct Input {
    std:: vector <double> numbers;
    size_t bin_count;
};


 Input input_data(istream& inp, bool prompt) {
Input in;
if (prompt){
size_t number_count;
cerr << "Enter number count: "; inp >> number_count;


in.numbers.resize(number_count);
 for (size_t i = 0; i < number_count; i++) {
        cerr << "Enter [" << i << "]: "; inp >> in.numbers[i];
    }

in.bin_count;
cerr << "Enter bin count: "; inp >> in.bin_count;
}
else {
    size_t number_count;
     inp >> number_count;



in.numbers.resize(number_count);
 for (size_t i = 0; i < number_count; i++) {
        inp >> in.numbers[i];
    }

in.bin_count;
inp >> in.bin_count;
}
    return in;
}

size_t write_data (void* items, size_t item_size, size_t item_count, void* ctx) {

    size_t data_size = item_size * item_count;

    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);

    return data_size;
}

Input
download(const string& address) {
    stringstream buffer;

    CURL* curl = curl_easy_init();
    if (curl){
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        if (res != 0) {
            cout << curl_easy_strerror(res);
            exit(1);
        }

  if(!res) {
    /* check the size */
    double dla;
    res = curl_easy_getinfo(curl, CURLINFO_SIZE_DOWNLOAD, &dla);
    if(!res) {
     cerr << "Download size " << dla << " bytes\n" ;
    }
  }

  }
}


int main(int argc, char* argv[])
{
    Input in;
    if (argc > 1) {
        in = download(argv[1]);
        }
    else {
        in = input_data(cin, true);
    }

auto  bins = make_histogram(in.numbers, in.bin_count);

show_histogram_svg ( bins );



return 0;
}
